/**
 * ErrorResponse.java
 *
 * File generated from the core::ErrorResponse uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class ErrorResponse.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ErrorResponse", propOrder = {
	"message",
	"detail",
	"requestID",
	"type"
})
@XmlRootElement(name = "ErrorResponse")
public class ErrorResponse implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "message", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public String message;
	@XmlElement(name = "detail", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.DetailType detail;
	@XmlAttribute(name = "requestID")
	public java.lang.String requestID;
	@XmlAttribute(name = "type")
	public net.ihe.gazelle.hpd.TypeType type;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return message.
	 * @return message
	 */
	public String getMessage() {
	    return message;
	}
	
	/**
	 * Set a value to attribute message.
	 * @param message.
	 */
	public void setMessage(String message) {
	    this.message = message;
	}
	
	
	
	
	/**
	 * Return detail.
	 * @return detail
	 */
	public net.ihe.gazelle.hpd.DetailType getDetail() {
	    return detail;
	}
	
	/**
	 * Set a value to attribute detail.
	 * @param detail.
	 */
	public void setDetail(net.ihe.gazelle.hpd.DetailType detail) {
	    this.detail = detail;
	}
	
	
	
	
	/**
	 * Return requestID.
	 * @return requestID
	 */
	public java.lang.String getRequestID() {
	    return requestID;
	}
	
	/**
	 * Set a value to attribute requestID.
	 * @param requestID.
	 */
	public void setRequestID(java.lang.String requestID) {
	    this.requestID = requestID;
	}
	
	
	
	
	/**
	 * Return type.
	 * @return type
	 */
	public net.ihe.gazelle.hpd.TypeType getType() {
	    return type;
	}
	
	/**
	 * Set a value to attribute type.
	 * @param type.
	 */
	public void setType(net.ihe.gazelle.hpd.TypeType type) {
	    this.type = type;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "ErrorResponse").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ErrorResponse errorResponse, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (errorResponse != null){
   			cvm.validate(errorResponse, _location, diagnostic);
			net.ihe.gazelle.hpd.DetailType.validateByModule(errorResponse.getDetail(), _location + "/detail", cvm, diagnostic);
    	}
    }

}